#ifndef __Parse_h_
#define __Parse_h_

#include <stdio.h>

/**
 * Die Klasse Parser dient dazu, die Syntax einer Kommandozeile zu berprfen und 
 * sie in ihre Bestandteile zu zerlegen. Eine von Parser abgeleitete Klasse kann 
 * auf die bei der Zerlegung einer Kommandozeile in internen Strukturen abgelegten 
 * Komponenten (Wrter) direkt zugreifen.
 *
 * Hinweis: Es ist vorgesehen, dass die Klasse Parser als Basisklasse fr den 
 *          Interpreter dient.
 *
 * @author Arbeitsgruppe EOS
 */
class Parser {
protected:
    /**
     * Setzt den Parser in einen initialen Zustand zurck, indem die 
     * Ablagestrukturen gelscht oder auf NULL gesetzt werden.
     */
    void clear();
public:
    /**
     * Erzeugt eine Instanze der Klasse Parser.
     */
    Parser();
    ~Parser();
        
    /**
     * Gibt den Inhalt der Struktur, die zur Ablage der beim parsen gefundenen
     * Komponenten (Wrter) dient, auf dem Bildschirm aus.
     * Diese Methode dient nur zur Kontrolle der Funktionsweise des Parsers!
     */
    void output();
    
    /**
     * Parst den bergebenen String und legt die gefundenen Komponenten (Wrte) 
     * in einer Struktur, die vom Interpreter ausgewertet werden kann, ab.
     *
     * @param str String der geparst werden soll
     * @return Liefert 1 wenn der String erfolgreich geparst werden konnte
     *         und -1 wenn ein Fehler aufgetreten ist.
     */
    int parse(char *str);
};

#endif // __Parse_h_
