#ifndef __fsdirectory_include__
#define __fsdirectory_include__

#include <sys/types.h>
#include "FSObject.hh"

class FSDirectory : public FSObject {
public:
    FSDirectory(FSLogic *logic) : FSObject(logic) {}
    FSDirectory(FSLogic *logic, const char* name) : FSObject(logic, name) {}

    /**
     * Prints the path of current working directory.
     */
    char* pwd();
    
    /**
     * Prints the content of the directory.
     */
    int readdir();
    
    /**
     * Identifies this object as a directory.
     */
    Type type() { return Directory; }
};

#endif // __fsdirectory_include__
