#ifndef __FsError_include__
#define __FsError_include__

class FSError {
public:
    typedef enum {
        NoError,          // alles klar, kein Fehler
        FsSpecificError,  // unbekannte Dateisystemfehler
        FileNotFound,     // :-)
        PermissionDenied, // Fehlende Berechtigung (z.B. schreiben auf CD)
        DiskFull,         // kein Speicherplatz mehr
        AttribBindFailed, // es konnte kein Attributobjekt erzeugt werden
        IOError,          // wollte Micha haben
        NotSupported      // :-)
    } Code;
private:
    Code _code;
public:
    FSError(Code acode) : _code(acode) {};

    // retrieve error information
    const char* message();
    Code code(void) { return _code; };

    // compare error codes
    bool operator == (FSError& error) { return (_code == error.code()); }
    bool operator != (FSError& error) { return (_code != error.code()); }

    // returns true if there was no error
    operator bool() { return (_code == NoError); }
};

#endif
