#ifndef __FSResult_h__
#define __FSResult_h__

class FSResult {
public:
    typedef enum {
        NoError,          // alles klar, kein Fehler
        EndOfFile,        // Ende der Datei, nicht wirklich ein Fehler
        FsSpecificError,  // unbekannte Dateisystemfehler
        FileNotFound,     // :-)
        PermissionDenied, // Fehlende Berechtigung (z.B. schreiben auf CD)
        DiskFull,         // kein Speicherplatz mehr
        AttribUnknown,    // Unbekanntes Attribute
        IOError,          // 
        NoMedium,         // Kein Medium im Laufwerk (z.B. bei Disketten)
        InvalidFS,        // Falsches Dateisystem auf dem Geraet
        InvalidForRoot,   // Unerlaubte Operation
        UninitializedObj, // Nicht initialisiertes Objekt
        ResourceLimit,    // Betriebsmittel im Dateisystem erschoefpft
        BufferTooSmall,   // Vom Aufrufer uebergebener Puffer ist zu klein
        NoDirectory,      // Das spezifizierte Objekt ist kein Verzeichnis
        NoFile,           // Das spezifizierte Objekt ist keine Datei
        NotSupported      // :-)
    } Code;

private:
    Code _code;
public:
    FSResult() : _code (NoError) {}
    FSResult(Code acode) : _code (acode) {}

    // retrieve error information
    const char* message () const;

    // compare error codes
    bool operator == (Code error) { return (_code == error); }
    bool operator != (Code error) { return (_code != error); }
    bool operator == (FSResult error) { return (_code == error._code); }
    bool operator != (FSResult error) { return (_code != error._code); }

    // returns true if there was no error
    operator bool() { return (_code == NoError); }
};

#endif // __FSResult_h__
