#include "Builtin.hh"
#include "Builtin.hh"
#include "BSShell.hh"

const Builtin::name Builtin::table[] = {
    {"exit", &Builtin::exit},
    {0, 0}
};

// ----------------------------------------------------------------------------
// class Builtin
Builtin::Builtin() {}

Builtin::~Builtin() {}

int Builtin::is_builtin(const char *cmdname) const {
    int i = 0;
    while (table[i].cmd) {
        if (!strcmp(table[i].cmd, cmdname)) return i;
        i++;
    }
    return -1;
}

int Builtin::execute(int refnr, int argv, char **argc) const {
    CmdFunction function = table[refnr].func;
    if (function) {
        return (this->*function)(argv, argc);
    }
    return -1;
}

int Builtin::exit(int, char **) const {
    return 0;
}
