#include "FSFile.hh"

int FSFile::lseek(size_t offset, int whence) {
    switch (whence) {
        case SEEK_SET : 
            _filepos = offset;
            break;
        case SEEK_END :
            _filepos = _filesize + offset;
            break;
        default:
            _filepos += offset;
    }
    return _filepos;
}

int FSFile::read(caddr_t buffer, size_t size) {
    int result = -1;
    
    if ((_filepos + size) < _size) {
        result = _logic->read(buffer, _start, _filepos, size);
        if (result > 0)
            _filepos += result;
    }
    return result;
}

int FSFile::write(const caddr_t buffer, size_t size) {
    int result = _logic->write(buffer, _start, _filepos, size);
    if (result > 0) {
        _filepos += result;
        if (_filepos > _size) 
            _size = _filepos;
    }
    return result;
}
