#include "FSResult.hh"

const char* FSResult::message () const {
    switch (_code) {
        case NoError:          return "no error";
        case EndOfFile:        return "end of file or directory reached";
        case FsSpecificError:  return "filesystem specific error";
        case FileNotFound:     return "file not found";
        case PermissionDenied: return "permission denied";
        case DiskFull:         return "disk full";
        case AttribUnknown:    return "attribute unknown";
        case IOError:          return "i/o error";
        case NotSupported:     return "function not supported";
        case NoMedium:         return "no medium";
        case InvalidFS:        return "invalid filesystem on device";
        case InvalidForRoot:   return "invalid operation on a filesystem's root";
        case ResourceLimit:    return "resource limit reached";
        case BufferTooSmall:   return "buffer is too small";
        case NoDirectory:      return "specified object is no directory";
        case NoFile:           return "specified object is no regular file";
        default:               return "unknown error";
    }
}
