#include <string.h>

//ToFix: 
#include "FileSystem.hh"
#include "FSLogic.hh"

char path[1024];
char devicepath[1024];

FSLogic *logic = 0;
FileSystem *fs = 0;

void SelectDevice(char *devname) {
    logic = new FSLogic(devname);
    if (!logic) { 
        fprintf(stdout, "\n      >>>> Error opening: %s\n", devname);
        return;
    }
    fs = new FileSystem(logic);
    fs->chdir(path);
}

void SelectPath(char *pathname) {
    fs->chdir(pathname);
}

void ListDirectory() {
    fs->readdir();
}

void create_dir(char *name) {
    fs->mkdir(name);
}

void read_file(char *name) {
    int fd = fs->open(name, 0);
    char buffer[1024];
    
    fprintf(stdout, "\n");
    while (fs->read(fd, buffer, 1024) > 0) {
        fprintf(stdout, "%s", buffer);
    }
}
   
int main(int argc, char** argv) {
    char c[2];
    char name[200];
    strcpy(path, "/");


    fprintf(stdout,"      Testprogram for VFAT-Filesystemdriver\n");
    fprintf(stdout,"      =====================================\n\n");
    while(1) {
        fprintf(stdout,"      Your current path is: %s\n", path);
        fprintf(stdout,"      Menu:\n");
        fprintf(stdout,"      s - select a device\n");
        fprintf(stdout,"      p - set directory\n");
        fprintf(stdout,"      l - list directory\n");
        fprintf(stdout,"      d - create an new directory\n");
        fprintf(stdout,"      r - read a file\n");
        fprintf(stdout,"      q - quit\n\n");
        fprintf(stdout,"      Your choice? ");
        std::cin.getline(c, 2, '\n');
        if(c[0] == 'q') break;
        switch (c[0]) {
            case 's':
                fprintf(stdout,"      Please enter devicename: ");
                std::cin.getline(name, 200, '\n');
                SelectDevice(name);
                break;
            case 'p':
                fprintf(stdout,"      Please enter pathname: ");
                std::cin.getline(name, 200, '\n');
                SelectPath(name);
                break;
            case 'l':
                ListDirectory();
                break;
            case 'd':
                fprintf(stdout,"      Please enter name of directory: ");
                std::cin.getline(name, 200, '\n');
                create_dir(name);
                break;
            case 'r':
                fprintf(stdout,"      Please enter name of file: ");
                std::cin.getline(name, 200, '\n');
                read_file(name);
                break;
        }
    }
    return 0;
}
